#!/usr/bin/env python3
# -*- coding: utf-8 -*-
#
# License: GNU General Public License v2
#
# Author: thl-cmk[at]outlook[dot]com
# URL   : https://thl-cmk.hopto.org
# Date  : 2022-04-29
#
# include file, will be used with juniper_bgp_peer and inv_juniper_bgp_peer
#
#

def juniper_address_type(st: str):
    names = {
        '0': 'unknown',
        '1': 'ipv4',
        '2': 'ipv6',
        '3': 'ipv4z',
        '4': 'ipv6z',
        '16': 'dns'
    }
    return names.get(st, st)


def juniper_address_family(st: str):
    names = {
        '0': 'unknown',
        '1': 'ipv4',
        '2': 'ipv6',
        '3': 'ipv4z',
        '4': 'ipv6z',
        '16': 'dns'
    }
    return names.get(st, st)


def juniper_afi_safi_mapping(afi: str, safi: str) -> str:
    names = {
        (1, 1): 'IPv4 unicast',
        (1, 2): 'IPv4 multicast',
        (1, 128): 'L3VPN IPv4 unicast',
        (1, 129): 'L3VPN IPv4 multicast',
        (2, 1): 'IPv6 unicast',
        (2, 2): 'IPv6 multicast',
        (25, 65): 'BGP-VPLS/BGP-L2VPN',
        (2, 128): 'L3VPN IPv6 unicast',
        (2, 129): 'L3VPN IPv6 multicast',
        (1, 132): 'RT-Constrain',
        (1, 133): 'Flow-spec',
        (1, 134): 'Flow-spec',
        (3, 128): 'CLNS VPN',
        (1, 5): 'NG-MVPN IPv4',
        (2, 5): 'NG-MVPN IPv6',
        (1, 66): 'MDT-SAFI',
        (1, 4): 'labeled IPv4',
        (2, 4): 'labeled IPv6 (6PE)',
    }
    return names.get((int(afi), int(safi)), f'AFI {afi} SAFI {safi}')
